/* template.c -- methods for xv_create(), xv_get(), xv_set(), and xv_destroy()
 *	(and xv_find() if you really need it)
 * Author:  Rick Goldstein
 */

#include <stdio.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include "template_impl.h"



/*
 * xv_create() method
 */
Pkg_private int
template_init ( Xv_opaque owner, Template_public *public, Attr_avlist avlist )
{
    Template_private *private = xv_alloc ( Template_private );

    public->private_data = (Xv_opaque) private;
    private->public_self = (Xv_opaque) public;

    /*
     * Parse Create-Only Attributes
     *
    for (attrs=avlist; *attrs; attrs=attr_next(attrs)) {
	switch ( (int) attrs[0] ) {
	    default:
	        break;
	
	}
    } 
    */

    return XV_OK;
} /* template_init() */




/*
 * xv_set() method
 */
Pkg_private Xv_opaque
template_set ( Template public, Attr_avlist avlist )
{
    Template_private *private = TEMPLATE_PRIVATE(public);
    Attr_avlist attrs;

    for (attrs=avlist; *attrs; attrs=attr_next(attrs)) {
	switch ( (int) attrs[0] ) {

	case XV_END_CREATE:
	    break;

	default:
	    xv_check_bad_attr ( TEMPLATE, attrs[0] );
	    break;
	} /* switch() */
    } /* for() */

    return XV_OK;
} /* template_set() */



/*
 * xv_get() method
 */
Pkg_private Xv_opaque
template_get ( Template_public   *public, 
	   int             *status,
	   Attr_attribute  attr,
	   Attr_avlist     args 
	   )
{
    Template_private *private = TEMPLATE_PRIVATE(public);

    switch ( (int) attr ) {
    default :
	*status = xv_check_bad_attr ( TEMPLATE, attr );
	return (Xv_opaque)XV_OK;
    } /* switch */

} /* template_get() */



/*
 * xv_destroy() method
 */
Pkg_private int
template_destroy ( Template_public *public, Destroy_status status )
{
    Template_private *private = TEMPLATE_PRIVATE(public);

    if (status == DESTROY_CLEANUP) {
        xv_free ( private );
    }
    return XV_OK;
} /* template_destroy() */


/*******************************************************************************/
