/* canvas.c -- canvas demonstration program
 * Author:  Kenneth Bibb
 */

#include <X11/Xlib.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/canvas.h>
#include <xview/scrollbar.h>
#include <xview/xv_xrect.h>

void draw_line(canvas, paint_window, display, xwin, xrects)
Canvas		canvas;
Xv_Window	paint_window;
Display		*display;
Window		xwin;
Xv_xrectlist	*xrects;
{
	GC	gc = DefaultGC(display, DefaultScreen(display));
	int	width = (int)xv_get(paint_window, XV_WIDTH);
	int	height = (int)xv_get(paint_window, XV_HEIGHT);

	XDrawLine(display, xwin, gc, 0, 0, width, height);
	XDrawLine(display, xwin, gc, 0, height, width, 0);
}

int main(argc, argv)
int argc;
char **argv;
{
	Frame		base;
	Canvas		canvas;
	Scrollbar	horiz, vert;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

	base = (Frame)xv_create(XV_NULL, FRAME,
		FRAME_LABEL,		argv[0],
		FRAME_SHOW_FOOTER,	TRUE,
		XV_X,			300,
		XV_Y,			175,
		NULL);

	canvas = (Canvas)xv_create(base, CANVAS,
		CANVAS_AUTO_EXPAND,	FALSE,
		CANVAS_AUTO_SHRINK,	FALSE,
		CANVAS_WIDTH,		1000,
		CANVAS_HEIGHT,		1000,
		CANVAS_REPAINT_PROC,	draw_line,
		CANVAS_X_PAINT_WINDOW,	TRUE,
		NULL);
	
	horiz = (Scrollbar)xv_create(canvas, SCROLLBAR,
		SCROLLBAR_DIRECTION,	SCROLLBAR_HORIZONTAL,
		SCROLLBAR_SPLITTABLE,	TRUE,
		NULL);
	
	vert =  (Scrollbar)xv_create(canvas, SCROLLBAR,
		SCROLLBAR_DIRECTION,	SCROLLBAR_VERTICAL,
		SCROLLBAR_SPLITTABLE,	TRUE,
		NULL);
	window_fit(base);

	xv_main_loop(base);
	return(0);
}
