/* frame.basic.c -- Open Look basic frame
 * Author:  Kenneth Bibb
 * January 1992 -- Arastar Consulting
 *-----------------------------------
 * Basic frame with panel and canvas
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/canvas.h>

main(argc, argv)
int argc;
char **argv;
{
	Frame		frame;
	Canvas		canvas;
	Panel		panel;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

	/* create the base frame */
	frame = (Frame)xv_create(NULL, FRAME,
		FRAME_LABEL,		argv[0],
		FRAME_SHOW_FOOTER,	TRUE,
		XV_X,			300,
		XV_Y,			175,
		NULL);

	/* create the panel */
	panel = (Panel)xv_create(frame, PANEL, NULL);
	window_fit_height(panel);

	/* create the canvas */
	canvas = (Canvas)xv_create(frame, CANVAS, 
		XV_X, 0,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		CANVAS_X_PAINT_WINDOW,	TRUE,
		NULL);

	/* fit the frame around the canvas and panel */
	window_fit(frame);

	xv_main_loop(frame);
}

