/* iconload.c -- Load an icon at runtime
 * Author:  Kenneth Bibb
 * April 1992 -- Arastar Consulting
 *--------------------------------------
 *
 * o Load an icon from a file
 *
 * o Only works with X11 bitmap format files
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/svrimage.h>
#include <xview/icon.h>


usage(s)
char *s;
{
	printf("Usage: %s filename\n",s);
	exit(1);
}

main(argc, argv)
int argc;
char **argv;
{
	Frame		base;
	Icon		ldicon;
	Server_image	image0;
	Panel		panel;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

	if(argc < 2)
		usage(argv[0]);

	image0 = (Server_image)xv_create(XV_NULL,SERVER_IMAGE,
		SERVER_IMAGE_BITMAP_FILE, argv[1],
		NULL);
	ldicon = (Icon)xv_create(XV_NULL,ICON,
			ICON_IMAGE, image0,
			ICON_LABEL, "loaded",
			NULL);
	base = (Frame)xv_create(NULL, FRAME,
		FRAME_LABEL,	argv[0],
		FRAME_CLOSED,	TRUE,
		FRAME_ICON,	ldicon,
		XV_X,		300,
		XV_Y,		175,
		NULL);
	panel = (Panel)xv_create(base, PANEL, NULL);

	xv_main_loop(base);
}

