/* frame.basic.c -- Open Look basic frame
 * Author:  Kenneth Bibb
 * January 1992 -- Arastar Consulting
 *-----------------------------------
 * Basic frame with panel and canvas
 */

#include <stdlib.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/canvas.h>
#define XK_LATIN1 1
#include <X11/keysymdef.h>

void fullsize(frame, event)
Frame frame;
Event *event;
{
	printf("fullsize \n");
	(void)xv_set(frame,
		XV_WIDTH, 200,
		XV_HEIGHT, 300,
		XV_SHOW, TRUE,
		NULL);
}

void restore(frame,event)
Frame frame;
Event *event;
{
	printf("restore\n");
	(void)xv_set(frame,
		XV_WIDTH,  200,
		XV_HEIGHT, 100,
		XV_SHOW, TRUE,
		NULL);
}

void quit(frame, event)
Frame frame;
Event *event;
{
	printf("quit\n");
	exit();
}

main(argc, argv)
int argc;
char **argv;
{
	Frame		frame;
	Canvas		canvas;
	Panel		panel;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

	/* create the base frame */
	frame = (Frame)xv_create(NULL, FRAME,
		FRAME_LABEL,		argv[0],
		FRAME_SHOW_FOOTER,	TRUE,
		XV_X,			300,
		XV_Y,			175,
		XV_WIDTH,		200,
		XV_HEIGHT,		100,
		NULL);
	(void)xv_set(frame,
		FRAME_X_ACCELERATOR,	XK_m, fullsize, frame,
		FRAME_ACCELERATOR,	'q', quit, frame,
		FRAME_ACCELERATOR,	'r', restore, frame,
		NULL);

	/* create the panel */
	panel = (Panel)xv_create(frame, PANEL, NULL);
	window_fit_height(panel);

	/* create the canvas */
	canvas = (Canvas)xv_create(frame, CANVAS, 
		XV_X, 0,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		CANVAS_X_PAINT_WINDOW,	TRUE,
		NULL);

	/* fit the frame around the canvas and panel */
	window_fit(frame);

	xv_main_loop(frame);
}

