/* misc.c -- Open Look miscellaneous features
 * Author:  Kenneth Bibb
 * Jan 1992 -- Arastar Consulting
 *-----------------------------------
 */

#include <stdlib.h>
#include <sys/param.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/canvas.h>
#include <xview/xv_xrect.h>
#include <xview/openmenu.h>
#include <xview/icon.h>
#include <xview/svrimage.h>

int my_usage(name)
char *name;
{
	printf("This is a programmer defined\n");
	printf("Usage message\n\n");
	xv_usage(name);
	exit(XV_OK);
}

int main(argc, argv)
int argc;
char **argv;
{
	Frame frame;
	Canvas		canvas;
	Panel		panel;

	/* initialization
	 */
	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv,
		XV_USAGE_PROC,	my_usage,
		NULL);
	/* create something for the DEPTH attribute to work on
	 */
	frame = (Frame)xv_create(NULL, FRAME,
		FRAME_LABEL,	argv[0],
		FRAME_CLOSED,	TRUE,
		XV_X,		300,
		XV_Y,		175,
		NULL);



/* version check */
#ifdef XV_VERSION_NUMBER
	printf("XV_version: [%s]\n",xv_version);
#else
	printf("There is no version number\n");
#endif




/* color check */
#ifdef XV_VERSION_NUMBER
	printf("This system is %s\n",(xv_get(frame,XV_DEPTH) == 1)
		? "monochrome" : "color");
#else
	printf("This system is %s\n",(xv_get(frame,WIN_DEPTH) == 1)
		? "monochrome" : "color");
#endif



	xv_main_loop(frame);
	return(0);
}
