/*
 * commander.c - Test of xv_system() call.
 */

#include <stdio.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/notify.h>


/*
 * Global object definitions.
 */
Frame	base_frame;

/*
 *  Function to receive the return value of the child process invoked by
 *  xv_system().
 */
Notify_value
wait_return(client, pid, status, rusage)
Notify_client	client;
int		pid;
union wait 	*status;
struct rusage	*rusage;
{
    if (WIFEXITED(*status)) {
	char msg[50];

	sprintf(msg, "Process %d returned with status %d.", pid, 
	    status->w_retcode);
	xv_set(base_frame, FRAME_LEFT_FOOTER, msg, NULL);
	return NOTIFY_DONE;
    }
    else
	return NOTIFY_IGNORED;
}


/*
 * Notify callback function for `cmd_item'.
 */
Panel_setting
cmd_notify(item, event)
	Panel_item	item;
	Event		*event;
{
    char msg[50];
    int pid;
    
    pid = xv_system((char *)xv_get(item, PANEL_VALUE), wait_return);
    sprintf(msg, "Process %d launched.", pid);
    xv_set(base_frame, FRAME_LEFT_FOOTER, msg, NULL);
    return panel_text_notify(item, event);
}

main(argc, argv)
int	argc;
char	**argv;
{
    Panel panel;

    xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

    base_frame = xv_create(NULL, FRAME,
	XV_LABEL, "Command Executor",
	FRAME_SHOW_FOOTER, TRUE,
	NULL);

    panel = xv_create(base_frame, PANEL,
	WIN_BORDER, TRUE,
	NULL);

    (void)xv_create(panel, PANEL_TEXT,
	XV_X,	16,
	XV_Y,	16,
	PANEL_VALUE_DISPLAY_LENGTH, 40,
	PANEL_VALUE_STORED_LENGTH, 80,
	PANEL_LABEL_STRING, "Command:",
	PANEL_NOTIFY_PROC, cmd_notify,
	NULL);

    window_fit(panel);
    window_fit(base_frame);

    xv_main_loop(base_frame);
    exit(0);
}
