#include <xview/notify.h>

/*
 *  xv_system() -- an XView replacement for system().  First argument is
 *  that of a string to be passed to /bin/sh executed as a child process,
 *  second argument is the function to be called when the child process
 *  returns.  If func is NULL, the default proc will be called.
 *
 *  return is pid if we forked successfully, -1 if we didn't.
 */
int
xv_system(s, func)
char *s;
Notify_func func;
{
    static Notify_client xv_sys_client = 42;   /* an arbitrary value */
    pid_t pid;

    pid = fork();
    if ( pid == -1) {		/* error */
	return -1;
    }
    else if ( pid == 0 ) {	/* child */
	execl("/usr/bin/sh","sh","-c", s, (char *)NULL);
	_exit(127);
    }

    if ( func == NULL )
	notify_set_wait3_func(xv_sys_client, notify_default_wait3, pid);
    else
	notify_set_wait3_func(xv_sys_client, func, pid);

    return pid;
}
