/* msglog.c -- Open Look message log
 * Author:  Kenneth Bibb
 * February 1992 -- Arastar Consulting
 */

#include <time.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/canvas.h>
#include <xview/xv_xrect.h>
#include <xview/openmenu.h>
#include <xview/textsw.h>
#include <xview/notice.h>

Attr_attribute  LOGWIN_KEY;
Attr_attribute	TEXTSW_KEY;

void view_log(menu, menu_item)
Menu menu;
Menu_item menu_item;
{
	Frame frame = xv_get(menu, XV_KEY_DATA, LOGWIN_KEY);

	if(xv_get(frame, XV_SHOW) == FALSE)
		xv_set(frame,
			XV_SHOW, TRUE,
			NULL);
}

void err_buttons(item, event)
Panel_item item;
Event *event;
{
	Textsw te = xv_get(item, XV_KEY_DATA, TEXTSW_KEY);
	char sbuf[80], s2buf[80];
	char *s=sbuf, *s2=s2buf;
	time_t tt;
	struct tm *tm;
	int len;

	time(&tt);
	tm=localtime(&tt);
	len = strftime(s2,80,"%a %m/%d/%y %H:%M:%S",tm);
	if(strcmp((char *)xv_get(item,PANEL_LABEL_STRING),"Error 1")==0)
	{
		sprintf(s,"%s\tQuietly decapitating kittens\n",s2);
		len += 30;
		textsw_insert(te,s,len);
	}
	else
	{
		sprintf(s,"%s\tLoudly punting a tomcat\n",s2);
		len += 25;
		textsw_insert(te,s,len);
	}
}


int main(argc, argv)
int argc;
char **argv;
{
	Frame		frame;
	Frame		Flog;
	Textsw		textsw;
	Panel		panel;
	Menu		menu;
	char		sbuf[48];
	char		*s=sbuf;




	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
	TEXTSW_KEY = xv_unique_key();
	LOGWIN_KEY = xv_unique_key();

	/* create the base frame 
	 */
	frame = (Frame)xv_create(XV_NULL, FRAME,
		FRAME_LABEL,	argv[0],
		XV_X,		300,
		XV_Y,		175,
		NULL);

	/* create the message log frame and associated stuff
	 */
	sprintf(s, "%s: Message Log", argv[0]);
	Flog =  (Frame)xv_create(frame, FRAME_CMD,
		FRAME_LABEL,	s,
		XV_X,		305,
		XV_Y,		220,
		NULL);
	textsw = (Textsw)xv_create(Flog, TEXTSW,
		XV_X,				0,
		XV_Y,				0,
		XV_WIDTH,			WIN_EXTEND_TO_EDGE,
		XV_HEIGHT,			WIN_EXTEND_TO_EDGE,
		TEXTSW_AGAIN_RECORDING,		FALSE,
		TEXTSW_CHECKPOINT_FREQUENCY,	0,
		TEXTSW_DISABLE_CD,		TRUE,
		TEXTSW_DISABLE_LOAD,		TRUE,
		TEXTSW_HISTORY_LIMIT,		0,
		TEXTSW_IGNORE_LIMIT,		TEXTSW_INFINITY,
		TEXTSW_READ_ONLY,		TRUE,
		NULL);
	window_fit(Flog);

	/* back to our regularly scheduled program
	 */
	menu  = (Menu)xv_create(XV_NULL, MENU,
		MENU_ITEM,
			MENU_STRING, "Message Log",
			NULL,
		MENU_NOTIFY_PROC, view_log,
		XV_KEY_DATA, LOGWIN_KEY, Flog,
		NULL),


	panel = (Panel)xv_create(frame, PANEL,
		NULL);

	(void)xv_create(panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"View",
		PANEL_ITEM_MENU,	menu,
		NULL);

	(void)xv_create(panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"Error 1",
		XV_KEY_DATA, TEXTSW_KEY, textsw,
		PANEL_NOTIFY_PROC,	err_buttons,
		NULL);

	(void)xv_create(panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"Error 2",
		PANEL_NOTIFY_PROC,	err_buttons,
		XV_KEY_DATA, TEXTSW_KEY, textsw,
		NULL);

	window_fit(panel);
	window_fit(frame);

	xv_main_loop(frame);
	return(0);
}

