/* ttysw.c -- Open Look tty sub window
 * Author:  Kenneth Bibb
 * April 1992 -- Arastar Consulting
 *-----------------------------------
 * Basic frame with panel and ttysw
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/tty.h>

Attr_attribute TTY_KEY=NULL;

void ls(button, event)
Panel_item button;
Event *event;
{
	char *lsmsg="ls\n";

	ttysw_input(xv_get(button,XV_KEY_DATA,TTY_KEY),lsmsg,strlen(lsmsg));
}

void clear(button, event)
Panel_item button;
Event *event;
{
	char *clmsg="clear\n";

	ttysw_input(xv_get(button,XV_KEY_DATA,TTY_KEY),clmsg,strlen(clmsg));
}

void iconize(button, event)
Panel_item button;
Event *event;
{
	char *icmsg="[2t";

	ttysw_output(xv_get(button,XV_KEY_DATA,TTY_KEY),icmsg,strlen(icmsg));
}

int main(argc, argv)
int argc;
char **argv;
{
	Frame		base;
	Tty		tty;
	Panel		panel;
	Panel_item	pc, pl, pi;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
	TTY_KEY = xv_unique_key();

	/* create the base frame */
	base = (Frame)xv_create(NULL, FRAME,
		FRAME_LABEL,		argv[0],
		FRAME_SHOW_FOOTER,	TRUE,
		XV_X,			300,
		XV_Y,			175,
		NULL);

	/* create the panel */
	panel = (Panel)xv_create(base, PANEL, NULL);

	/* create some buttons */
	pc = (Panel_item)xv_create(panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"Clear",
		PANEL_NOTIFY_PROC,	clear,
		NULL);
	pl = (Panel_item)xv_create(panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"ls",
		PANEL_NOTIFY_PROC,	ls,
		NULL);
	pi = (Panel_item)xv_create(panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"Iconize",
		PANEL_NOTIFY_PROC,	iconize,
		NULL);
	window_fit_height(panel);

	/* create the ttysw */
	tty = (Tty)xv_create(base, TTY, 
		WIN_ROWS,	24,
		WIN_COLUMNS,	80,
		TTY_QUIT_ON_CHILD_DEATH, TRUE,
		NULL);
	(void)xv_set(pc, XV_KEY_DATA, TTY_KEY, tty,NULL);
	(void)xv_set(pl, XV_KEY_DATA, TTY_KEY, tty,NULL);
	(void)xv_set(pi, XV_KEY_DATA, TTY_KEY, tty,NULL);

	/* fit the frame around the ttysw and panel */
	window_fit(base);

	xv_main_loop(base);
	return(0);
}

