/*
 *  mbtty -- Bare minimum lister for the msgboard.
 */

#include <sys/param.h>
#include <stdio.h>
#include "msgboard.h"

Mem_Rec
    *ulist,			/*  Pointer to list of users		*/
    *myentry;			/*  Pointer to current user's record in
				    ulist array				*/

char
    mb_server[MAXHOSTNAMELEN+1],
    **cats,			/* Pointer to array of category names	*/
    mylogid[L_cuserid];		/* Current user's login ID		*/

int 
    users = 0,				/* Number of users in datalist	*/
    numcats = 0,			/* Number of categories known	*/
    cur_cat = MB_ALL,			/* Category to restrict display to */
    cur_status = MB_ALL,		/* Category to restrict display to */
    admin = FALSE,			/* Is user in admin mode?	*/
    admin_enable = TRUE,
    newmsgs = FALSE;			/* Did they get new messages? */

Global_Rec
    globrec;				/* Global data from server	*/

void
pr_msg(ignore, bell, format, a1, a2, a3)
int bell;
char *ignore, *format, *a1, *a2, *a3;
{
    if (bell) fputc('\007', stderr);
    fprintf(stderr, format, a1, a2, a3);
    fputc('\n', stderr);
}

main(argc, argv)
int argc;
char **argv;
{
    if (cuserid(mylogid) == CNULL) {
	pr_msg(NULL, TRUE, "System doesn't know who %s is! (cuserid failed)",
	    mylogid);
	exit(1);
    }

    if (!connect_to_server()) {
	pr_msg(NULL, TRUE, "Could not connect to server %s.", mb_server);
	exit(1);
    }

    (void)get_modified_records();
}

void
update_screen()
{
    static char *status[3] = {
	"out",
	"in",
	"???"
    };
    int i;

    printf("Message Board for %s:\n", globrec.name);
    if (globrec.motd[0] != '\0') printf("    ** %s **\n", globrec.motd);
    for (i = 0; i < users; i++) {
	printf("%s", ulist[i].fname);
	if (ulist[i].ext[0] !='\0') printf(", x%s", ulist[i].ext);
	printf(": %s", status[ulist[i].status]);
	if (ulist[i].until[0] != '\0') printf(" until %s", ulist[i].until);
	if (ulist[i].comment[0] != '\0') printf(" - %s", ulist[i].comment);
	printf("\n");
    }
    if (newmsgs) printf("(You have new phone messages)\n");
}

void
set_mainwin_items_status()
{
    if (myentry != NULL && (myentry->flags & MB_NEWMSGS) != 0)
	newmsgs = TRUE;
}

void
update_line(rp)
Mem_Rec *rp;
{
}

void
update_global_display()
{
}

void
update_cat_list()
{
}

void
watch_del()
{
}

void
watch_alert()
{
}

void
server_was_dropped()
{
}
