.TH MSGBOARD 1 "13 Sep 1991"
.SH NAME
msgboard,msglock,imin,imout \- distributed message board
.SH SYNOPSIS
.B msgboard
.br
.B msglock
[ 
.I lock_program
[
.I lock_args
] ]
.br
.B imin
.br
.B imout
.SH DESCRIPTION
.I msgboard
provides a way to easily let everyone in an office know where everyone
else is.  The board has one line for each person in the office that
shows their name, whether they're "In" or "Out," when they're expected
back, and an optional comment.

Clicking on any line on the board selects it.  You may also select a
person's line by typing the first character of their last name.  Once
you have selected a line, you may execute one of the board's other
functions, such as "Send Pmsg" or "Page."

Clicking on the In/Out portion of your own line moves you from In to
Out or vice versa.  When you move to Out, a pop-up window appears,
allowing you to enter when you'll be back and an additional message.
This same pop-up can be brought up at any time by clicking on the Edit
button or using the list's menu and selecting "Modify Entry..."

A user with admin capabilities can change the information of other
users; they can also use the Edit button's menu to add new users and
delete old ones.  A
.I msgboard
admin can also use the program's property sheet to create or change a
one-line message, which will appear just above the main list, 
and the site name, which appears in the title bar of the main window.

Since this is a distributed system, changes you make will be reflected
on the window of any other user running
.IR msgboard ;
initially, the program checks for changes every 30 seconds, although
this can be changed on the property sheet.  The ideal use of this
program is to have an office receptionist run
.I msgboard
with admin capabilities, while other members of the office can run it
(or the simpler programs
.IR imin ,
.I imout
and
.IR msglock )
to show whether they are In or Out.  Users who do not have access to a
computer or choose not to run the program for other reasons can then
have their information updated by the receptionist as needed.

.I msglock
lets you easily incorporate the features of
.I msgboard
with your usual lockscreen program.  When you run
.IR msglock ,
a window pops up on your screen asking you for your return time and optional
explanatory message.  When you click on the Apply button, you are marked as
Out and the lockscreen program you specified, either on the command line or
on the
.I msglock
window, is run.  When you exit your lockscreen program, you're
automatically marked as In again.

The easiest way to use
.I msglock
is to simply insert its name in front of any
reference to your favorite lockscreen program, especially in your root menu.
For example, change

	"Lock Screen"		exec xlock -mode random

to

	"Lock Screen"		exec msglock xlock -mode random

.I imin
and
.I imout
are command-line programs that mark you as In and Out, respectively.
You can use these when you're not running within a window system such
as X, or if you just prefer to use a command-line interface.

.SHRESOURCES
.I msgboard
itself does not currently recognize any resources.
.I msglock
does, however.  Its class name is "MsgLock", so the string "MsgLock." (including the period) must precede any of the following names in the left-hand side of the resource specification.

	Program (string)	Default value for "Lock Program" field

	Until (string)		Default value for "Until" field

	Message (string)	Default value for "Message" field

	Timeout (integer)	Number of seconds program will wait for
				input before it gives up and runs the
				specified lock screen program

	Warntime (integer)	Time when countdown timer becomes visible
	
	AutoOutsApply (boolean)	If true, selecting an item from the msglock
				Outs menu automatically performs an Apply.
				(default is True)

	CenterScreen (boolean)	If true, place the msglock window in the
				center of the screen. (default is True)
	
.SH FILES
	~/.msgboardrc		file program settings are saved in

.SH SEE ALSO
The "instants" describing use of the program for admins.
