/*
 * From: sdo@soliado.East.Sun.COM (Scott Oaks - Sun Consulting NYC)
 *
 *  Call this function when you get the mouse down event which
 *  initiates the drag event, passing it the cursor you want displayed
 *  and the filename that the receiving tool should get as the d-n-d
 *  event.
 */

#include <xview/xview.h>
#include <xview/fullscreen.h>
#include <X11/X.h>
#include <X11/Xatom.h>

xview_send_drag_event(src_win, cursor, fname)
    Xv_opaque	src_win, cursor;
    char	*fname;

{
Xv_opaque	fullscreen, dest_win_xid;
Inputmask	im;
Event		event;
int		data[5];
Atom		drop_atom;

    fullscreen = xv_create(0, FULLSCREEN,
			FULLSCREEN_INPUT_WINDOW, 	src_win,
			FULLSCREEN_SYNC,		TRUE,
			WIN_CURSOR,			cursor,
			WIN_CONSUME_EVENTS,		WIN_MOUSE_BUTTONS, NULL,
			NULL);
    input_imnull(&im);
    win_setinputcodebit(&im, MS_LEFT);
    win_setinputcodebit(&im, LOC_DRAG);
    im.im_flags = IM_NEGEVENT;

    XAllowEvents(xv_get(src_win, XV_DISPLAY), SyncPointer, CurrentTime);
    do {
	xv_input_readevent(src_win, &event, TRUE, TRUE, &im);
    } while (!(win_inputnegevent(&event) && event_action(&event) == ACTION_SELECT));

    fullscreen_destroy(fullscreen);

    dest_win_xid = win_pointer_under(src_win, event_x(&event), event_y(&event));

    drop_atom = XInternAtom(xv_get(src_win, XV_DISPLAY), "FOOBAR", FALSE);
    XChangeProperty(xv_get(src_win, XV_DISPLAY),
		    xv_get(src_win, XV_XID), drop_atom,
		    XA_STRING, 8, PropModeReplace,
		    (Xv_opaque) fname, strlen(fname) + 1);
    data[0] = XV_POINTER_WINDOW;
    data[1] = event_x(&event);
    data[2] = event_y(&event);
    data[3] = xv_get(src_win, XV_XID);
    data[4] = drop_atom;

    xv_send_message(src_win, dest_win_xid, "XV_DO_DRAG_LOAD", 32, data, 20);
}

