/*
 *  warpme.c -- warp the pointer to the center of a button -- ONLY if the
 *	user wants us to!
 */

#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/defaults.h>

static Display *dewarp_dpy;
static Window dewarp_win;
static int dewarp_x, dewarp_y, dewarp_pending = FALSE;

void
warpme(frame, panel, button)
Frame frame;
Panel panel;
Panel_item button;
{
    int mouse_x, mouse_y;
    Window junk, win;

    if ( ! defaults_get_boolean("openwindows.popupjumpcursor",
	"OpenWindows.PopupJumpCursor", TRUE) )
	return;

    mouse_x = (int)xv_get(button, XV_X) + (int)xv_get(button, XV_WIDTH) / 2;
    mouse_y = (int)xv_get(button, XV_Y) + (int)xv_get(button, XV_HEIGHT) / 2;

    dewarp_dpy = (Display *)xv_get(frame, XV_DISPLAY);
    win = (int)xv_get(panel, XV_XID);

    (void)XQueryPointer(
	dewarp_dpy,	/* Display */
	win,		/* Pass it a real window to keep it happy, but we
			   don't really care */
	&dewarp_win,	/* Save root window for dewarp function */
	&junk,		/* child window -- don't care */
	&dewarp_x,	/* Mouse x location relative to root window */
	&dewarp_y,	/* Mouse y " 				    */
	&junk,		/* x relative to child window -- don't care */
	&junk,		/* y "					    */
	&junk);		/* modifier key status -- don't care	    */

    XWarpPointer(
	dewarp_dpy,		/* display	*/
	None,			/* src_w	*/
	win,			/* dest_w	*/
	None,			/* src_x	*/
	None,			/* src_y	*/
	None,			/* src_width	*/
	None,			/* src_height	*/
	mouse_x,		/* dest_x	*/
	mouse_y			/* dest_y	*/
	);
    dewarp_pending = TRUE;
}

/*
 *  Call this function when any criterion for doing the dewarp is violated
 */
void
no_dewarp()
{
    dewarp_pending = FALSE;
}

/*
 *  Returns the mouse to its rightful place, but only if we never called
 *  no_dewarp() .
 */
void
dewarp()
{
    if (!dewarp_pending) return;

    XWarpPointer(
	dewarp_dpy,		/* display	*/
	None,			/* src_w	*/
	dewarp_win,		/* dest_w	*/
	None,			/* src_x	*/
	None,			/* src_y	*/
	None,			/* src_width	*/
	None,			/* src_height	*/
	dewarp_x,		/* dest_x	*/
	dewarp_y		/* dest_y	*/
	);
    dewarp_pending = FALSE;
}
